=== third_party/requirements.txt ===
# Python requirements modules
# Formatting the source code
clang-format==15.0.7
cmake-format==0.6.13
black==24.3.0
# Tests
packaging==24.2
# Generating HTML documentation
pygments==2.19.1
sphinxcontrib_applehelp==2.0.0
sphinxcontrib_devhelp==2.0.0
sphinxcontrib_htmlhelp==2.1.0
sphinxcontrib_serializinghtml==2.0.0
sphinxcontrib_qthelp==2.0.0
breathe==4.36.0
sphinx==8.1.3
sphinx_book_theme==1.1.3
# Spelling check in documentation
pyenchant==3.2.2
sphinxcontrib-spelling==8.0.1
