=== debian/changelog ===
intel-umf (0.11.0-0ubuntu1~26.04) resolute; urgency=medium

  * Initial package upload (LP: #2130189).
    - d/watch: upgrade to version 5.
    - d/watch: produce consistent parent folder name in orig tarball
      using v5 d/watch.
    - d/copyright: add files flagged by licensecheck -r.
    - d/copyright: improve accuracy of license reporting.
    - d/intel-umf0.symbols: Add symbols control file for libumf0.

 -- Will French <will.french@canonical.com>  Wed, 25 Feb 2026 10:46:59 -0600
