=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --builddir build --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DUMF_BUILD_SHARED_LIBRARY=ON \
		-DUMF_BUILD_CUDA_PROVIDER=OFF \
		-DUMF_LEVEL_ZERO_INCLUDE_DIR=/usr/include/level_zero \
		-DUMF_BUILD_EXAMPLES=OFF \
		-DUMF_BUILD_TESTS=OFF
