=== debian/watch ===
Version: 5

Template: Github
Owner: oneapi-src
Project: unified-memory-framework
Download-Url-Mangle: s%https://api.github.com/repos/([^/]+/[^/]+)/git/refs/tags/(.*)%https://github.com/$1/archive/refs/tags/$2.tar.gz%
Filename-Mangle: s%.*/tags/(.*)%unified-memory-framework-$1.tar.gz%
Repack: yes
Update-Script: uupdate
